/*      module.c
 *
 * A minimal module playing example with the DLL API
 *
 * Copyright 1996,1997 Housemarque Inc.
 *
 * This file is part of MIDAS Digital Audio System, and may only be
 * used, modified and distributed under the terms of the MIDAS
 * Digital Audio System license, "license.txt". By continuing to use,
 * modify or distribute this file you indicate that you have
 * read the license and understand and accept it fully.
*/


#include <stdio.h>
#include <stdlib.h>
#include "midasdll.h"

#include "main.h"


#include <Application.h>

int main(void)
{
   

	BApplication myApplication("application/x.vnd-misc",0);


    /* Error checking has been removed for clarity - see other API examples */

    /* Initialize MIDAS and start background playback: */
    MIDASstartup();
   puts("Startup OK..\n");
    MIDASinit();
   puts("Init OK..\n");
    MIDASstartBackgroundPlay(0);
   puts("BackgroundPlay OK..\n");

    /* Load the module and start playing: */
   module = MIDASloadModule("Lizardking - Wild Impressions.mod");
   puts("Loaded Module OK..\n");
   

    playHandle = MIDASplayModule(module, TRUE);
//printf("ok so far!!\n");

    puts("\nPlaying - press any key\n");

    getchar();


    /* Stop playing and deallocate module: */
    MIDASstopModule(playHandle);
    MIDASfreeModule(module);

    /* Stop background playback and uninitialize MIDAS: */
    MIDASstopBackgroundPlay();
    MIDASclose();

    return 0;
}
